--[[
    A big thanks to otravi and his castingbar, most of the bar code is taken 
	from his addon and warped for my evil purposes here.
    
    Textures for the castbar taken from agUF and oCB
--]]


local Colors = 
{
	complete	= {r=0, g=1, b=0},
	autoShot	= {r=1, g=.7, b=0},
	aimedShot	= {r=.3, g=.3, b=1},
	failed		= {r=1, g=0, b=0},
}

local Textures  =
{
	["Perl"]    = "Interface\\AddOns\\BigTrouble\\textures\\perl",
	["Smooth"]	= "Interface\\AddOns\\BigTrouble\\textures\\smooth",
	["Glaze"]	= "Interface\\AddOns\\BigTrouble\\textures\\glaze",
	["Default"]	= "Interface\\TargetingFrame\\UI-StatusBar",
    ["BantoBar"]    = "Interface\\AddOns\\BigTrouble\\textures\\BantoBar",
    ["Gloss"] 	= "Interface\\AddOns\\BigTrouble\\textures\\Gloss",
}

local startTime, maxValue, delayString, delayTime
local isCasting, isAutoShot, skipSpellCastStop
local thresHold

BigTrouble = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDebug-2.0", "AceDB-2.0", "AceConsole-2.0")
local L = AceLibrary("AceLocale-2.2"):new("BigTrouble")

function BigTrouble:OnInitialize()

	self:RegisterDB("BigTroubleDB")
	self:RegisterChatCommand( {"/btrouble"}, self.options )
	self:RegisterDefaults('profile', {
	    Bar = {
			width		= 255,
			height		= 25,
			timeSize	= 12,
			spellSize	= 12,
			delaySize	= 14,
			border		= true,
            texture	    = "Default",
	    },
	    aimedDelay	= 0.35,
		pos			= {},
		autoShotBar	= true,
		aimedShotBar	= true
	})
	
	self:SetDebugging(false)

end

function BigTrouble:OnEnable()

	self.locked = true
	self.opt = self.db.profile
    
	self:CreateFrameWork()

	self:RegisterEvent("START_AUTOREPEAT_SPELL", "StartAutoRepeat")
	self:RegisterEvent("STOP_AUTOREPEAT_SPELL", "StopAutoRepeat")
	-- self:RegisterEvent("PLAYER_ENTERING_WORLD", "PlayerEnteringWorld")
	self:RegisterEvent("UNIT_SPELLCAST_SENT", "SpellCastSent"); -- These are triggered by our instants, like multi, arcane etc
	self:RegisterEvent("UNIT_SPELLCAST_START", "SpellCastStart");
	self:RegisterEvent("UNIT_SPELLCAST_STOP", "SpellCastStop");
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED","SpellCastFailed")
	self:RegisterEvent("UNIT_SPELLCAST_DELAYED", "SpellCastDelayed");
	self:RegisterEvent("UNIT_SPELLCAST_FAILED", "SpellCastFailed");	

end

function BigTrouble:SpellCastSent(id, spell, rank, target)
	self:Debug(event, id, spell, rank, target)
    if (id ~= "player" or spell == L["Auto Shot"]) then return end
    skipSpellCastStop = true
end

 function BigTrouble:SpellCastFailed(unit)
    if(unit ~= "player" or (not isCasting and isAutoShot)) then return end
 	self:Debug(event)
  	 
 	 --[[
 	 	We use this to check if we are actaully shooting anything, this since
 	 	autoShot is turned off before this event gets called and hence cannot
 	 	be used to check if we are doing something
 	 --]]
 	 if( self.master:IsShown() ) then
        isCasting = false
 	 	self.master.Spark:Hide()
 	         
 	 	self.master.Bar:SetValue( maxValue )
 	 	self.master.Bar:SetStatusBarColor( Colors.failed.r, Colors.failed.g, Colors.failed.b )
 	 	self.master.Spell:SetText(L[event])
 	 end
 
 end

function BigTrouble:SpellCastStart(unit)
	if( unit ~= "player" ) then return end
    
	local name, nameSubtext, text, texture, start, endt, isTradeSkill = UnitCastingInfo(unit)
    if( name ~= L["Aimed Shot"] ) then return end
    
    self:Debug(event, name)
	startTime = start / 1000
	maxValue = endt / 1000
	isCasting = true
    skipSpellCastStop = true
    
	self.master.Bar:SetStatusBarColor( Colors.aimedShot.r, Colors.aimedShot.g, Colors.aimedShot.b )
	self:BarCreate(text)

end

function BigTrouble:SpellCastDelayed( unit )
 	if( unit ~= "player") then return end
 
 	 if( self.master:IsShown() ) then
		local _, _, _, _, startTime, endTime, _, oldStart = UnitCastingInfo(unit)
		local oldStart = startTime
		startTime = start / 1000
		maxValue = endt / 1000
		delayTime = (delayTime or 0) + ( startTime - oldStart )
        
        delayString = "+"..string.format( "%.1f", delayTime )
 	         
 	 	self.master.Bar:SetMinMaxValues( startTime, maxValue )
 	 end
 
 end
 
function BigTrouble:StartAutoRepeat()
    isAutoShot = true
	self:Debug(event)
end

function BigTrouble:StopAutoRepeat()
	self:Debug(event)
    isAutoShot = false
end

 function BigTrouble:SpellCastStop(unit)
	if (unit ~= "player") then return end;
    self:Debug(event, skipSpellCastStop)
 
    if( isCasting ) then isCasting = false end    
    if( skipSpellCastStop ) then skipSpellCastStop = false return end
    
    if( isAutoShot ) then
        startTime = GetTime()
        maxValue = startTime + UnitRangedDamage("player")
        
 	 	self.master.Bar:SetStatusBarColor( Colors.autoShot.r, Colors.autoShot.g, Colors.autoShot.b )
 	 	self:BarCreate(L["Auto Shot"]) 
 	 end
 
 end

 function BigTrouble:BarCreate(s)

	self.master.Bar:SetMinMaxValues( startTime, maxValue )
	self.master.Bar:SetValue( startTime )
	self.master.Spell:SetText(s)
	self.master:SetAlpha(1)
	self.master.Time:SetText("")
	self.master.Delay:SetText("")

	delayString = nil
	thresHold = false

	self.master:Show()
	self.master.Spark:Show()

end

function BigTrouble:SavePosition()

	local x, y = self.master:GetLeft(), self.master:GetTop()
	local s = self.master:GetEffectiveScale()

	self.opt.pos.x = x * s
	self.opt.pos.y = y * s

end

function BigTrouble:SetPosition()

	if self.opt.pos.x then
		local x = self.opt.pos.x
		local y = self.opt.pos.y
	
		local s = self.master:GetEffectiveScale()

		self.master:ClearAllPoints()
		self.master:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x / s, y / s)
	else
		self.master:ClearAllPoints()
		self.master:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	end

end

function BigTrouble:CreateFrameWork()

	self.master = CreateFrame("Frame", "BigTroubleFrame", UIParent)
	self.master:Hide()
    
	self.master:SetScript( "OnUpdate", self.OnCasting )
	self.master:SetMovable(true)
	self.master:EnableMouse(true)
	self.master:RegisterForDrag("LeftButton")
	self.master:SetScript("OnDragStart", function() if not self.locked then self["master"]:StartMoving() end end)
	self.master:SetScript("OnDragStop", function() self["master"]:StopMovingOrSizing() self:SavePosition() end)

	self.master.Bar   = CreateFrame("StatusBar", nil, self.master)
	self.master.Spark = self.master.Bar:CreateTexture(nil, "OVERLAY")
	self.master.Time  = self.master.Bar:CreateFontString(nil, "OVERLAY")
	self.master.Spell = self.master.Bar:CreateFontString(nil, "OVERLAY")
	self.master.Delay = self.master.Bar:CreateFontString(nil, "OVERLAY")
    
    self:Layout()

end

function BigTrouble:Layout()

	local gameFont, _, _ = GameFontHighlightSmall:GetFont()
    
	self.master:SetWidth( self.opt.Bar.width + 9 )
	self.master:SetHeight( self.opt.Bar.height + 10 )

    local edgeFile, edgeSize
	if self.opt.Bar.border then 
		edgeFile, edgeSize = "Interface\\Tooltips\\UI-Tooltip-Border", 16 
	end
	
	self.master:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
		edgeFile = edgeFile or "", 
		edgeSize = edgeSize or "",
		insets = {left = 5, right = 5, top = 5, bottom = 5},
	})

    self.master:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b)
	self.master:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)

	self.master.Bar:ClearAllPoints()
	self.master.Bar:SetPoint("CENTER", self.master, "CENTER", 0, 0)
	self.master.Bar:SetWidth( self.opt.Bar.width )
	self.master.Bar:SetHeight( self.opt.Bar.height )
	self.master.Bar:SetStatusBarTexture( Textures[self.opt.Bar.texture] )

	self.master.Spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	self.master.Spark:SetWidth(16)
	self.master.Spark:SetHeight( self.opt.Bar.height + 25 )
	self.master.Spark:SetBlendMode("ADD")

	self.master.Time:SetJustifyH("RIGHT")
	self.master.Time:SetFont( gameFont, self.opt.Bar.timeSize )
	self.master.Time:SetText("X.Y")
	self.master.Time:ClearAllPoints()
	self.master.Time:SetPoint("RIGHT", self.master.Bar, "RIGHT",-10,0)

	self.master.Spell:SetJustifyH("CENTER")
	self.master.Spell:SetWidth( self.opt.Bar.width - self.master.Time:GetWidth() )
	self.master.Spell:SetFont( gameFont, self.opt.Bar.spellSize )
	self.master.Spell:ClearAllPoints()
	self.master.Spell:SetPoint("LEFT", self.master, "LEFT",10,0)

	self.master.Delay:SetTextColor(1,0,0,1)
	self.master.Delay:SetJustifyH("RIGHT")
	self.master.Delay:SetFont( gameFont, self.opt.Bar.delaySize )
	self.master.Delay:SetText("X.Y")
	self.master.Delay:ClearAllPoints()
	self.master.Delay:SetPoint("TOPRIGHT", self.master.Bar, "TOPRIGHT",-10,20)

	self:SetPosition()

end

function BigTrouble:OnCasting()
	if( ( isCasting or isAutoShot ) and not thresHold ) then
		local currentTime = GetTime()
        
		if( currentTime > maxValue ) then
			currentTime = maxValue
			thresHold = true
		end

		BigTrouble.master.Time:SetText( string.format( "%.1f", ( maxValue - currentTime )))
		if( delayTime ~= 0 ) then BigTrouble.master.Delay:SetText( delayString ) end
		BigTrouble.master.Bar:SetValue( currentTime )

		local sparkProgress = (( currentTime - startTime ) / ( maxValue - startTime )) * BigTrouble.opt.Bar.width
		BigTrouble.master.Spark:SetPoint("CENTER", BigTrouble.master.Bar, "LEFT", sparkProgress, 0)
	else
		local a = BigTrouble.master:GetAlpha() - .05

		if( a > 0 ) then
			BigTrouble.master:SetAlpha(a)
		else
			BigTrouble.master:Hide()
			BigTrouble.master.Time:SetText("")
			BigTrouble.master.Delay:SetText("")
			BigTrouble.master:SetAlpha(1)
		end
	end

end

--[[
	Stupid fix for reseting state when zoning and AutoShot or
	Aimed Shot is casting
--]]
--function BigTrouble:PlayerEnteringWorld()

--	isAutoShot = false
--	isCasting = false
	
--	if( self.locked ) then self.master:Hide() end

--end

